Index: /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 54296)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 54297)
@@ -522,5 +522,4 @@
         case UIExtraDataMetaDefs::RuntimeMenuMachineActionType_SettingsDialog:    strResult = "SettingsDialog"; break;
         case UIExtraDataMetaDefs::RuntimeMenuMachineActionType_TakeSnapshot:      strResult = "TakeSnapshot"; break;
-        case UIExtraDataMetaDefs::RuntimeMenuMachineActionType_TakeScreenshot:    strResult = "TakeScreenshot"; break;
         case UIExtraDataMetaDefs::RuntimeMenuMachineActionType_InformationDialog: strResult = "InformationDialog"; break;
         case UIExtraDataMetaDefs::RuntimeMenuMachineActionType_Pause:             strResult = "Pause"; break;
@@ -551,5 +550,4 @@
     keys << "SettingsDialog";    values << UIExtraDataMetaDefs::RuntimeMenuMachineActionType_SettingsDialog;
     keys << "TakeSnapshot";      values << UIExtraDataMetaDefs::RuntimeMenuMachineActionType_TakeSnapshot;
-    keys << "TakeScreenshot";    values << UIExtraDataMetaDefs::RuntimeMenuMachineActionType_TakeScreenshot;
     keys << "InformationDialog"; values << UIExtraDataMetaDefs::RuntimeMenuMachineActionType_InformationDialog;
     keys << "Pause";             values << UIExtraDataMetaDefs::RuntimeMenuMachineActionType_Pause;
@@ -581,4 +579,5 @@
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_GuestAutoresize:   strResult = "GuestAutoresize"; break;
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_AdjustWindow:      strResult = "AdjustWindow"; break;
+        case UIExtraDataMetaDefs::RuntimeMenuViewActionType_TakeScreenshot:    strResult = "TakeScreenshot"; break;
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_MenuBar:           strResult = "MenuBar"; break;
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_MenuBarSettings:   strResult = "MenuBarSettings"; break;
@@ -611,4 +610,5 @@
     keys << "GuestAutoresize";   values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_GuestAutoresize;
     keys << "AdjustWindow";      values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_AdjustWindow;
+    keys << "TakeScreenshot";    values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_TakeScreenshot;
     keys << "MenuBar";           values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_MenuBar;
     keys << "MenuBarSettings";   values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_MenuBarSettings;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 54296)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 54297)
@@ -365,15 +365,14 @@
         RuntimeMenuMachineActionType_SettingsDialog    = RT_BIT(0),
         RuntimeMenuMachineActionType_TakeSnapshot      = RT_BIT(1),
-        RuntimeMenuMachineActionType_TakeScreenshot    = RT_BIT(2),
-        RuntimeMenuMachineActionType_InformationDialog = RT_BIT(3),
-        RuntimeMenuMachineActionType_Pause             = RT_BIT(10),
-        RuntimeMenuMachineActionType_Reset             = RT_BIT(11),
-        RuntimeMenuMachineActionType_SaveState         = RT_BIT(12),
-        RuntimeMenuMachineActionType_Shutdown          = RT_BIT(13),
-        RuntimeMenuMachineActionType_PowerOff          = RT_BIT(14),
+        RuntimeMenuMachineActionType_InformationDialog = RT_BIT(2),
+        RuntimeMenuMachineActionType_Pause             = RT_BIT(3),
+        RuntimeMenuMachineActionType_Reset             = RT_BIT(4),
+        RuntimeMenuMachineActionType_SaveState         = RT_BIT(5),
+        RuntimeMenuMachineActionType_Shutdown          = RT_BIT(6),
+        RuntimeMenuMachineActionType_PowerOff          = RT_BIT(7),
 #ifndef RT_OS_DARWIN
-        RuntimeMenuMachineActionType_Close             = RT_BIT(15),
+        RuntimeMenuMachineActionType_Close             = RT_BIT(8),
 #endif /* !RT_OS_DARWIN */
-        RuntimeMenuMachineActionType_Nothing           = RT_BIT(16),
+        RuntimeMenuMachineActionType_Nothing           = RT_BIT(9),
         RuntimeMenuMachineActionType_All               = 0xFFFF
     };
@@ -388,13 +387,14 @@
         RuntimeMenuViewActionType_GuestAutoresize   = RT_BIT(3),
         RuntimeMenuViewActionType_AdjustWindow      = RT_BIT(4),
-        RuntimeMenuViewActionType_MenuBar           = RT_BIT(5),
-        RuntimeMenuViewActionType_MenuBarSettings   = RT_BIT(6),
-        RuntimeMenuViewActionType_ToggleMenuBar     = RT_BIT(7),
-        RuntimeMenuViewActionType_StatusBar         = RT_BIT(8),
-        RuntimeMenuViewActionType_StatusBarSettings = RT_BIT(9),
-        RuntimeMenuViewActionType_ToggleStatusBar   = RT_BIT(10),
-        RuntimeMenuViewActionType_ScaleFactor       = RT_BIT(11),
-        RuntimeMenuViewActionType_Resize            = RT_BIT(12),
-        RuntimeMenuViewActionType_Multiscreen       = RT_BIT(13),
+        RuntimeMenuViewActionType_TakeScreenshot    = RT_BIT(5),
+        RuntimeMenuViewActionType_MenuBar           = RT_BIT(6),
+        RuntimeMenuViewActionType_MenuBarSettings   = RT_BIT(7),
+        RuntimeMenuViewActionType_ToggleMenuBar     = RT_BIT(8),
+        RuntimeMenuViewActionType_StatusBar         = RT_BIT(9),
+        RuntimeMenuViewActionType_StatusBarSettings = RT_BIT(10),
+        RuntimeMenuViewActionType_ToggleStatusBar   = RT_BIT(11),
+        RuntimeMenuViewActionType_ScaleFactor       = RT_BIT(12),
+        RuntimeMenuViewActionType_Resize            = RT_BIT(13),
+        RuntimeMenuViewActionType_Multiscreen       = RT_BIT(14),
         RuntimeMenuViewActionType_All               = 0xFFFF
     };
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 54296)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 54297)
@@ -135,39 +135,4 @@
 };
 
-class UIActionSimplePerformTakeScreenshot : public UIActionSimple
-{
-    Q_OBJECT;
-
-public:
-
-    UIActionSimplePerformTakeScreenshot(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/screenshot_take_16px.png", ":/screenshot_take_disabled_16px.png") {}
-
-protected:
-
-    /** Returns action extra-data ID. */
-    virtual int extraDataID() const { return UIExtraDataMetaDefs::RuntimeMenuMachineActionType_TakeScreenshot; }
-    /** Returns action extra-data key. */
-    virtual QString extraDataKey() const { return gpConverter->toInternalString(UIExtraDataMetaDefs::RuntimeMenuMachineActionType_TakeScreenshot); }
-    /** Returns whether action is allowed. */
-    virtual bool isAllowed() const { return actionPool()->toRuntime()->isAllowedInMenuMachine(UIExtraDataMetaDefs::RuntimeMenuMachineActionType_TakeScreenshot); }
-
-    QString shortcutExtraDataID() const
-    {
-        return QString("TakeScreenshot");
-    }
-
-    QKeySequence defaultShortcut(UIActionPoolType) const
-    {
-        return QKeySequence("E");
-    }
-
-    void retranslateUi()
-    {
-        setName(QApplication::translate("UIActionPool", "Take Screensh&ot..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Take a screenshot of the virtual machine"));
-    }
-};
-
 class UIActionSimpleShowInformationDialog : public UIActionSimple
 {
@@ -644,4 +609,39 @@
 };
 
+class UIActionSimplePerformTakeScreenshot : public UIActionSimple
+{
+    Q_OBJECT;
+
+public:
+
+    UIActionSimplePerformTakeScreenshot(UIActionPool *pParent)
+        : UIActionSimple(pParent, ":/screenshot_take_16px.png", ":/screenshot_take_disabled_16px.png") {}
+
+protected:
+
+    /** Returns action extra-data ID. */
+    virtual int extraDataID() const { return UIExtraDataMetaDefs::RuntimeMenuViewActionType_TakeScreenshot; }
+    /** Returns action extra-data key. */
+    virtual QString extraDataKey() const { return gpConverter->toInternalString(UIExtraDataMetaDefs::RuntimeMenuViewActionType_TakeScreenshot); }
+    /** Returns whether action is allowed. */
+    virtual bool isAllowed() const { return actionPool()->toRuntime()->isAllowedInMenuView(UIExtraDataMetaDefs::RuntimeMenuViewActionType_TakeScreenshot); }
+
+    QString shortcutExtraDataID() const
+    {
+        return QString("TakeScreenshot");
+    }
+
+    QKeySequence defaultShortcut(UIActionPoolType) const
+    {
+        return QKeySequence("E");
+    }
+
+    void retranslateUi()
+    {
+        setName(QApplication::translate("UIActionPool", "Take Screensh&ot..."));
+        setStatusTip(QApplication::translate("UIActionPool", "Take a screenshot of the virtual machine"));
+    }
+};
+
 class UIActionMenuMenuBar : public UIActionMenu
 {
@@ -1995,5 +1995,4 @@
     m_pool[UIActionIndexRT_M_Machine_S_Settings] = new UIActionSimpleShowSettingsDialog(this);
     m_pool[UIActionIndexRT_M_Machine_S_TakeSnapshot] = new UIActionSimplePerformTakeSnapshot(this);
-    m_pool[UIActionIndexRT_M_Machine_S_TakeScreenshot] = new UIActionSimplePerformTakeScreenshot(this);
     m_pool[UIActionIndexRT_M_Machine_S_ShowInformation] = new UIActionSimpleShowInformationDialog(this);
     m_pool[UIActionIndexRT_M_Machine_T_Pause] = new UIActionTogglePause(this);
@@ -2014,4 +2013,5 @@
     m_pool[UIActionIndexRT_M_View_T_GuestAutoresize] = new UIActionToggleGuestAutoresize(this);
     m_pool[UIActionIndexRT_M_View_S_AdjustWindow] = new UIActionSimplePerformWindowAdjust(this);
+    m_pool[UIActionIndexRT_M_View_S_TakeScreenshot] = new UIActionSimplePerformTakeScreenshot(this);
     m_pool[UIActionIndexRT_M_View_M_MenuBar] = new UIActionMenuMenuBar(this);
     m_pool[UIActionIndexRT_M_View_M_MenuBar_S_Settings] = new UIActionSimpleShowMenuBarSettingsWindow(this);
@@ -2277,6 +2277,4 @@
     /* 'Take Snapshot' action: */
     fSeparator = addAction(pMenu, action(UIActionIndexRT_M_Machine_S_TakeSnapshot)) || fSeparator;
-    /* 'Take Screenshot' action: */
-    fSeparator = addAction(pMenu, action(UIActionIndexRT_M_Machine_S_TakeScreenshot)) || fSeparator;
     /* 'Information Dialog' action: */
     fSeparator = addAction(pMenu, action(UIActionIndexRT_M_Machine_S_ShowInformation)) || fSeparator;
@@ -2345,4 +2343,14 @@
     /* 'Guest Autoresize' action: */
     fSeparator = addAction(pMenu, action(UIActionIndexRT_M_View_T_GuestAutoresize)) || fSeparator;
+
+    /* Separator: */
+    if (fSeparator)
+    {
+        pMenu->addSeparator();
+        fSeparator = false;
+    }
+
+    /* 'Take Screenshot' action: */
+    fSeparator = addAction(pMenu, action(UIActionIndexRT_M_View_S_TakeScreenshot)) || fSeparator;
 
     /* Separator: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h	(revision 54296)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h	(revision 54297)
@@ -43,5 +43,4 @@
     UIActionIndexRT_M_Machine_S_Settings,
     UIActionIndexRT_M_Machine_S_TakeSnapshot,
-    UIActionIndexRT_M_Machine_S_TakeScreenshot,
     UIActionIndexRT_M_Machine_S_ShowInformation,
     UIActionIndexRT_M_Machine_T_Pause,
@@ -62,4 +61,5 @@
     UIActionIndexRT_M_View_S_AdjustWindow,
     UIActionIndexRT_M_View_T_GuestAutoresize,
+    UIActionIndexRT_M_View_S_TakeScreenshot,
     UIActionIndexRT_M_View_M_MenuBar,
     UIActionIndexRT_M_View_M_MenuBar_S_Settings,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 54296)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 54297)
@@ -924,7 +924,7 @@
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_Machine_S_Settings));
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_Machine_S_TakeSnapshot));
-    m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_Machine_S_TakeScreenshot));
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_Machine_S_ShowInformation));
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_Machine_T_Pause));
+    m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_View_S_TakeScreenshot));
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar));
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_S_Settings));
@@ -972,6 +972,4 @@
     connect(actionPool()->action(UIActionIndexRT_M_Machine_S_TakeSnapshot), SIGNAL(triggered()),
             this, SLOT(sltTakeSnapshot()));
-    connect(actionPool()->action(UIActionIndexRT_M_Machine_S_TakeScreenshot), SIGNAL(triggered()),
-            this, SLOT(sltTakeScreenshot()));
     connect(actionPool()->action(UIActionIndexRT_M_Machine_S_ShowInformation), SIGNAL(triggered()),
             this, SLOT(sltShowInformationDialog()));
@@ -999,4 +997,6 @@
     connect(actionPool()->action(UIActionIndexRT_M_View_S_AdjustWindow), SIGNAL(triggered()),
             this, SLOT(sltAdjustWindow()));
+    connect(actionPool()->action(UIActionIndexRT_M_View_S_TakeScreenshot), SIGNAL(triggered()),
+            this, SLOT(sltTakeScreenshot()));
 
     /* 'Input' actions connections: */
@@ -1425,4 +1425,98 @@
 }
 
+void UIMachineLogic::sltShowInformationDialog()
+{
+    /* Do not process if window(s) missed! */
+    if (!isMachineWindowsCreated())
+        return;
+
+    /* Invoke VM information dialog: */
+    UIVMInfoDialog::invoke(mainMachineWindow());
+}
+
+void UIMachineLogic::sltReset()
+{
+    /* Confirm/Reset current console: */
+    if (msgCenter().confirmResetMachine(machineName()))
+        console().Reset();
+
+    /* TODO_NEW_CORE: On reset the additional screens didn't get a display
+       update. Emulate this for now until it get fixed. */
+    ulong uMonitorCount = machine().GetMonitorCount();
+    for (ulong uScreenId = 1; uScreenId < uMonitorCount; ++uScreenId)
+        machineWindows().at(uScreenId)->update();
+}
+
+void UIMachineLogic::sltPause(bool fOn)
+{
+    uisession()->setPause(fOn);
+}
+
+void UIMachineLogic::sltSaveState()
+{
+    /* Make sure machine is in one of the allowed states: */
+    if (!uisession()->isRunning() && !uisession()->isPaused())
+    {
+        AssertMsgFailed(("Invalid machine-state. Action should be prohibited!"));
+        return;
+    }
+
+    saveState();
+}
+
+void UIMachineLogic::sltShutdown()
+{
+    /* Make sure machine is in one of the allowed states: */
+    if (!uisession()->isRunning())
+    {
+        AssertMsgFailed(("Invalid machine-state. Action should be prohibited!"));
+        return;
+    }
+
+    shutdown();
+}
+
+void UIMachineLogic::sltPowerOff()
+{
+    /* Make sure machine is in one of the allowed states: */
+    if (!uisession()->isRunning() && !uisession()->isPaused() && !uisession()->isStuck())
+    {
+        AssertMsgFailed(("Invalid machine-state. Action should be prohibited!"));
+        return;
+    }
+
+    powerOff(machine().GetSnapshotCount() > 0);
+}
+
+void UIMachineLogic::sltClose()
+{
+    /* Do not process if window(s) missed! */
+    if (!isMachineWindowsCreated())
+        return;
+
+    /* Do not try to close machine-window if restricted: */
+    if (isPreventAutoClose())
+        return;
+
+    /* First, we have to close/hide any opened modal & popup application widgets.
+     * We have to make sure such window is hidden even if close-event was rejected.
+     * We are re-throwing this slot if any widget present to test again.
+     * If all opened widgets are closed/hidden, we can try to close machine-window: */
+    QWidget *pWidget = QApplication::activeModalWidget() ? QApplication::activeModalWidget() :
+                       QApplication::activePopupWidget() ? QApplication::activePopupWidget() : 0;
+    if (pWidget)
+    {
+        /* Closing/hiding all we found: */
+        pWidget->close();
+        if (!pWidget->isHidden())
+            pWidget->hide();
+        QTimer::singleShot(0, this, SLOT(sltClose()));
+        return;
+    }
+
+    /* Try to close active machine-window: */
+    activeMachineWindow()->close();
+}
+
 void UIMachineLogic::sltTakeScreenshot()
 {
@@ -1492,98 +1586,4 @@
     if (!strFilename.isEmpty())
         takeScreenshot(strFilename, strFilter.split(" ").value(0, "png"));
-}
-
-void UIMachineLogic::sltShowInformationDialog()
-{
-    /* Do not process if window(s) missed! */
-    if (!isMachineWindowsCreated())
-        return;
-
-    /* Invoke VM information dialog: */
-    UIVMInfoDialog::invoke(mainMachineWindow());
-}
-
-void UIMachineLogic::sltReset()
-{
-    /* Confirm/Reset current console: */
-    if (msgCenter().confirmResetMachine(machineName()))
-        console().Reset();
-
-    /* TODO_NEW_CORE: On reset the additional screens didn't get a display
-       update. Emulate this for now until it get fixed. */
-    ulong uMonitorCount = machine().GetMonitorCount();
-    for (ulong uScreenId = 1; uScreenId < uMonitorCount; ++uScreenId)
-        machineWindows().at(uScreenId)->update();
-}
-
-void UIMachineLogic::sltPause(bool fOn)
-{
-    uisession()->setPause(fOn);
-}
-
-void UIMachineLogic::sltSaveState()
-{
-    /* Make sure machine is in one of the allowed states: */
-    if (!uisession()->isRunning() && !uisession()->isPaused())
-    {
-        AssertMsgFailed(("Invalid machine-state. Action should be prohibited!"));
-        return;
-    }
-
-    saveState();
-}
-
-void UIMachineLogic::sltShutdown()
-{
-    /* Make sure machine is in one of the allowed states: */
-    if (!uisession()->isRunning())
-    {
-        AssertMsgFailed(("Invalid machine-state. Action should be prohibited!"));
-        return;
-    }
-
-    shutdown();
-}
-
-void UIMachineLogic::sltPowerOff()
-{
-    /* Make sure machine is in one of the allowed states: */
-    if (!uisession()->isRunning() && !uisession()->isPaused() && !uisession()->isStuck())
-    {
-        AssertMsgFailed(("Invalid machine-state. Action should be prohibited!"));
-        return;
-    }
-
-    powerOff(machine().GetSnapshotCount() > 0);
-}
-
-void UIMachineLogic::sltClose()
-{
-    /* Do not process if window(s) missed! */
-    if (!isMachineWindowsCreated())
-        return;
-
-    /* Do not try to close machine-window if restricted: */
-    if (isPreventAutoClose())
-        return;
-
-    /* First, we have to close/hide any opened modal & popup application widgets.
-     * We have to make sure such window is hidden even if close-event was rejected.
-     * We are re-throwing this slot if any widget present to test again.
-     * If all opened widgets are closed/hidden, we can try to close machine-window: */
-    QWidget *pWidget = QApplication::activeModalWidget() ? QApplication::activeModalWidget() :
-                       QApplication::activePopupWidget() ? QApplication::activePopupWidget() : 0;
-    if (pWidget)
-    {
-        /* Closing/hiding all we found: */
-        pWidget->close();
-        if (!pWidget->isHidden())
-            pWidget->hide();
-        QTimer::singleShot(0, this, SLOT(sltClose()));
-        return;
-    }
-
-    /* Try to close active machine-window: */
-    activeMachineWindow()->close();
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h	(revision 54296)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.h	(revision 54297)
@@ -251,5 +251,4 @@
 #endif /* Q_WS_X11 */
     void sltTakeSnapshot();
-    void sltTakeScreenshot();
     void sltShowInformationDialog();
     void sltReset();
@@ -259,4 +258,7 @@
     void sltPowerOff();
     void sltClose();
+
+    /* "View" menu functionality: */
+    void sltTakeScreenshot();
 
     /* "Device" menu functionality: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMenuBarEditorWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMenuBarEditorWindow.cpp	(revision 54296)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMenuBarEditorWindow.cpp	(revision 54297)
@@ -473,5 +473,4 @@
         prepareCopiedAction(pMenu, actionPool()->action(UIActionIndexRT_M_Machine_S_Settings));
         prepareCopiedAction(pMenu, actionPool()->action(UIActionIndexRT_M_Machine_S_TakeSnapshot));
-        prepareCopiedAction(pMenu, actionPool()->action(UIActionIndexRT_M_Machine_S_TakeScreenshot));
         prepareCopiedAction(pMenu, actionPool()->action(UIActionIndexRT_M_Machine_S_ShowInformation));
         pMenu->addSeparator();
@@ -496,4 +495,6 @@
         prepareCopiedAction(pMenu, actionPool()->action(UIActionIndexRT_M_View_S_AdjustWindow));
         prepareCopiedAction(pMenu, actionPool()->action(UIActionIndexRT_M_View_T_GuestAutoresize));
+        pMenu->addSeparator();
+        prepareCopiedAction(pMenu, actionPool()->action(UIActionIndexRT_M_View_S_TakeScreenshot));
         pMenu->addSeparator();
         prepareCopiedAction(pMenu, actionPool()->action(UIActionIndexRT_M_View_M_MenuBar));