Index: /trunk/src/VBox/Frontends/VBoxManage/VBoxManageControlVM.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxManage/VBoxManageControlVM.cpp	(revision 54420)
+++ /trunk/src/VBox/Frontends/VBoxManage/VBoxManageControlVM.cpp	(revision 54421)
@@ -1370,5 +1370,10 @@
         }
 #ifdef VBOX_WITH_VPX
-        else if (!strcmp(a->argv[1], "videocap"))
+        /* 
+         * Note: Commands starting with "vcp" are the deprecated versions and are 
+         *       kept to ensure backwards compatibility. 
+         */
+        else if (   !strcmp(a->argv[1], "videocap")
+                 || !strcmp(a->argv[1], "vcpenabled"))
         {
             if (a->argc != 3)
@@ -1393,5 +1398,6 @@
             }
         }
-        else if (   !strcmp(a->argv[1], "videocapscreens"))
+        else if (   !strcmp(a->argv[1], "videocapscreens")
+                 || !strcmp(a->argv[1], "vcpscreens"))
         {
             ULONG cMonitors = 64;
@@ -1441,5 +1447,6 @@
             CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureScreens)(ComSafeArrayAsInParam(saScreens)));
         }
-        else if (!strcmp(a->argv[1], "videocapfile"))
+        else if (   !strcmp(a->argv[1], "videocapfile")
+                 || !strcmp(a->argv[1], "vcpfile"))
         {
             if (a->argc != 3)
@@ -1480,43 +1487,30 @@
             CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureHeight)(uVal));
         }
-        else if (!strcmp(a->argv[1], "videocaprate"))
-        {
-            if (a->argc != 3)
-            {
-                errorSyntax(USAGE_CONTROLVM, "Incorrect number of parameters");
-                rc = E_FAIL;
-                break;
-            }
-
+        else if (!strcmp(a->argv[1], "vcpwidth")) /* Deprecated; keeping for compatibility. */
+        {
             uint32_t uVal;
             int vrc = RTStrToUInt32Ex(a->argv[2], NULL, 0, &uVal);
             if (RT_FAILURE(vrc))
             {
-                errorArgument("Error parsing rate '%s'", a->argv[2]);
-                rc = E_FAIL;
-                break;
-            }
-            CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureRate)(uVal));
-        }
-        else if (!strcmp(a->argv[1], "videocapfps"))
-        {
-            if (a->argc != 3)
-            {
-                errorSyntax(USAGE_CONTROLVM, "Incorrect number of parameters");
-                rc = E_FAIL;
-                break;
-            }   
-
+                errorArgument("Error parsing width '%s'", a->argv[2]);
+                rc = E_FAIL;
+                break;
+            }
+            CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureWidth)(uVal));
+        }
+        else if (!strcmp(a->argv[1], "vcpheight")) /* Deprecated; keeping for compatibility. */
+        {
             uint32_t uVal;
             int vrc = RTStrToUInt32Ex(a->argv[2], NULL, 0, &uVal);
             if (RT_FAILURE(vrc))
             {
-                errorArgument("Error parsing FPS '%s'", a->argv[2]);
-                rc = E_FAIL;
-                break;
-            }
-            CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureFPS)(uVal));
-        }
-        else if (!strcmp(a->argv[1], "videocapmaxtime"))
+                errorArgument("Error parsing height '%s'", a->argv[2]);
+                rc = E_FAIL;
+                break;
+            }
+            CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureHeight)(uVal));
+        }
+        else if (   !strcmp(a->argv[1], "videocaprate")
+                 || !strcmp(a->argv[1], "vcprate"))
         {
             if (a->argc != 3)
@@ -1525,5 +1519,5 @@
                 rc = E_FAIL;
                 break;
-            } 
+            }
 
             uint32_t uVal;
@@ -1531,11 +1525,12 @@
             if (RT_FAILURE(vrc))
             {
-                errorArgument("Error parsing maximum time '%s'", a->argv[2]);
-                rc = E_FAIL;
-                break;
-            }
-            CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureMaxTime)(uVal));
-        }
-        else if (!strcmp(a->argv[1], "videocapmaxsize"))
+                errorArgument("Error parsing rate '%s'", a->argv[2]);
+                rc = E_FAIL;
+                break;
+            }
+            CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureRate)(uVal));
+        }
+        else if (   !strcmp(a->argv[1], "videocapfps")
+                 || !strcmp(a->argv[1], "vcpfps"))
         {
             if (a->argc != 3)
@@ -1550,4 +1545,44 @@
             if (RT_FAILURE(vrc))
             {
+                errorArgument("Error parsing FPS '%s'", a->argv[2]);
+                rc = E_FAIL;
+                break;
+            }
+            CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureFPS)(uVal));
+        }
+        else if (   !strcmp(a->argv[1], "videocapmaxtime")
+                 || !strcmp(a->argv[1], "vcpmaxtime"))
+        {
+            if (a->argc != 3)
+            {
+                errorSyntax(USAGE_CONTROLVM, "Incorrect number of parameters");
+                rc = E_FAIL;
+                break;
+            } 
+
+            uint32_t uVal;
+            int vrc = RTStrToUInt32Ex(a->argv[2], NULL, 0, &uVal);
+            if (RT_FAILURE(vrc))
+            {
+                errorArgument("Error parsing maximum time '%s'", a->argv[2]);
+                rc = E_FAIL;
+                break;
+            }
+            CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureMaxTime)(uVal));
+        }
+        else if (   !strcmp(a->argv[1], "videocapmaxsize")
+                 || !strcmp(a->argv[1], "vcpmaxsize"))
+        {
+            if (a->argc != 3)
+            {
+                errorSyntax(USAGE_CONTROLVM, "Incorrect number of parameters");
+                rc = E_FAIL;
+                break;
+            }   
+
+            uint32_t uVal;
+            int vrc = RTStrToUInt32Ex(a->argv[2], NULL, 0, &uVal);
+            if (RT_FAILURE(vrc))
+            {
                 errorArgument("Error parsing maximum file size '%s'", a->argv[2]);
                 rc = E_FAIL;
@@ -1556,5 +1591,6 @@
             CHECK_ERROR_BREAK(sessionMachine, COMSETTER(VideoCaptureMaxFileSize)(uVal));
         }
-        else if (!strcmp(a->argv[1], "videocapopts"))
+        else if (   !strcmp(a->argv[1], "videocapopts")
+                 || !strcmp(a->argv[1], "vcpoptions"))
         {
             if (a->argc != 3)