Index: trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/converter/UIConverterBackendGlobal.cpp	(revision 54459)
@@ -586,5 +586,7 @@
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_MenuBar:              strResult = "MenuBar"; break;
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_MenuBarSettings:      strResult = "MenuBarSettings"; break;
+#ifndef Q_WS_MAC
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_ToggleMenuBar:        strResult = "ToggleMenuBar"; break;
+#endif /* !Q_WS_MAC */
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_StatusBar:            strResult = "StatusBar"; break;
         case UIExtraDataMetaDefs::RuntimeMenuViewActionType_StatusBarSettings:    strResult = "StatusBarSettings"; break;
@@ -621,5 +623,7 @@
     keys << "MenuBar";              values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_MenuBar;
     keys << "MenuBarSettings";      values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_MenuBarSettings;
+#ifndef Q_WS_MAC
     keys << "ToggleMenuBar";        values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_ToggleMenuBar;
+#endif /* !Q_WS_MAC */
     keys << "StatusBar";            values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_StatusBar;
     keys << "StatusBarSettings";    values << UIExtraDataMetaDefs::RuntimeMenuViewActionType_StatusBarSettings;
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.cpp	(revision 54459)
@@ -88,5 +88,7 @@
 const char* UIExtraDataDefs::GUI_LastScaleWindowPosition = "GUI/LastScaleWindowPosition";
 const char* UIExtraDataDefs::GUI_Geometry_State_Max = "max";
+#ifndef Q_WS_MAC
 const char* UIExtraDataDefs::GUI_MenuBar_Enabled = "GUI/MenuBar/Enabled";
+#endif /* !Q_WS_MAC */
 const char* UIExtraDataDefs::GUI_RestrictedRuntimeMenus = "GUI/RestrictedRuntimeMenus";
 #ifdef Q_WS_MAC
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataDefs.h	(revision 54459)
@@ -148,6 +148,8 @@
         /** Holds machine-window geometry maximized state flag. */
         extern const char* GUI_Geometry_State_Max;
+#ifndef Q_WS_MAC
         /** Holds Runtime UI menu-bar availability status. */
         extern const char* GUI_MenuBar_Enabled;
+#endif /* !Q_WS_MAC */
         /** Holds restricted Runtime UI menu types. */
         extern const char* GUI_RestrictedRuntimeMenus;
@@ -394,5 +396,7 @@
         RuntimeMenuViewActionType_MenuBar              = RT_BIT(10),
         RuntimeMenuViewActionType_MenuBarSettings      = RT_BIT(11),
+#ifndef RT_OS_DARWIN
         RuntimeMenuViewActionType_ToggleMenuBar        = RT_BIT(12),
+#endif /* !RT_OS_DARWIN */
         RuntimeMenuViewActionType_StatusBar            = RT_BIT(13),
         RuntimeMenuViewActionType_StatusBarSettings    = RT_BIT(14),
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.cpp	(revision 54459)
@@ -2511,4 +2511,5 @@
 }
 
+#ifndef Q_WS_MAC
 bool UIExtraDataManager::menuBarEnabled(const QString &strID)
 {
@@ -2522,4 +2523,5 @@
     setExtraDataString(GUI_MenuBar_Enabled, toFeatureRestricted(!fEnabled), strID);
 }
+#endif /* !Q_WS_MAC */
 
 UIExtraDataMetaDefs::MenuType UIExtraDataManager::restrictedRuntimeMenuTypes(const QString &strID)
@@ -3626,5 +3628,8 @@
 
         /* Menu-bar configuration change: */
-        if (strKey == GUI_MenuBar_Enabled ||
+        if (
+#ifndef Q_WS_MAC
+            strKey == GUI_MenuBar_Enabled ||
+#endif /* !Q_WS_MAC */
             strKey == GUI_RestrictedRuntimeMenus ||
 #ifdef Q_WS_MAC
Index: trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/extradata/UIExtraDataManager.h	(revision 54459)
@@ -300,8 +300,10 @@
         void setMachineWindowGeometry(UIVisualStateType visualStateType, ulong uScreenIndex, const QRect &geometry, bool fMaximized, const QString &strID);
 
+#ifndef Q_WS_MAC
         /** Returns whether Runtime UI menu-bar is enabled. */
         bool menuBarEnabled(const QString &strID);
         /** Defines whether Runtime UI menu-bar is @a fEnabled. */
         void setMenuBarEnabled(bool fEnabled, const QString &strID);
+#endif /* !Q_WS_MAC */
 
         /** Returns restricted Runtime UI menu types. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.cpp	(revision 54459)
@@ -816,4 +816,5 @@
 };
 
+#ifndef RT_OS_DARWIN
 class UIActionToggleMenuBar : public UIActionToggle
 {
@@ -846,4 +847,5 @@
     }
 };
+#endif /* !RT_OS_DARWIN */
 
 class UIActionMenuStatusBar : public UIActionMenu
@@ -2080,5 +2082,7 @@
     m_pool[UIActionIndexRT_M_View_M_MenuBar] = new UIActionMenuMenuBar(this);
     m_pool[UIActionIndexRT_M_View_M_MenuBar_S_Settings] = new UIActionSimpleShowMenuBarSettingsWindow(this);
+#ifndef RT_OS_DARWIN
     m_pool[UIActionIndexRT_M_View_M_MenuBar_T_Visibility] = new UIActionToggleMenuBar(this);
+#endif /* !RT_OS_DARWIN */
     m_pool[UIActionIndexRT_M_View_M_StatusBar] = new UIActionMenuStatusBar(this);
     m_pool[UIActionIndexRT_M_View_M_StatusBar_S_Settings] = new UIActionSimpleShowStatusBarSettingsWindow(this);
@@ -2565,6 +2569,8 @@
     /* 'Menu Bar Settings' action: */
     addAction(pMenu, action(UIActionIndexRT_M_View_M_MenuBar_S_Settings));
+#ifndef Q_WS_MAC
     /* 'Toggle Menu Bar' action: */
     addAction(pMenu, action(UIActionIndexRT_M_View_M_MenuBar_T_Visibility));
+#endif /* !Q_WS_MAC */
 
     /* Mark menu as valid: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIActionPoolRuntime.h	(revision 54459)
@@ -68,5 +68,7 @@
     UIActionIndexRT_M_View_M_MenuBar,
     UIActionIndexRT_M_View_M_MenuBar_S_Settings,
+#ifndef RT_OS_DARWIN
     UIActionIndexRT_M_View_M_MenuBar_T_Visibility,
+#endif /* !RT_OS_DARWIN */
     UIActionIndexRT_M_View_M_StatusBar,
     UIActionIndexRT_M_View_M_StatusBar_S_Settings,
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 54459)
@@ -935,5 +935,7 @@
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar));
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_S_Settings));
+#ifndef Q_WS_MAC
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_T_Visibility));
+#endif /* !Q_WS_MAC */
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_View_M_StatusBar));
     m_pRunningOrPausedActions->addAction(actionPool()->action(UIActionIndexRT_M_View_M_StatusBar_S_Settings));
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 54459)
@@ -1343,4 +1343,5 @@
         pGuestAutoresizeSwitch->setChecked(gEDataManager->guestScreenAutoResizeEnabled(strMachineID));
 
+#ifndef Q_WS_MAC
         /* Menu-bar options: */
         {
@@ -1355,4 +1356,5 @@
             pActionMenuBarSwitch->blockSignals(false);
         }
+#endif /* !Q_WS_MAC */
 
         /* Status-bar options: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp	(revision 54459)
@@ -113,11 +113,15 @@
     AssertReturnVoid(isMachineWindowsCreated());
 
+#ifndef Q_WS_MAC
     /* Make sure menu-bar is enabled: */
     const bool fEnabled = actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_T_Visibility)->isChecked();
     AssertReturnVoid(fEnabled);
+#endif /* !Q_WS_MAC */
 
     /* Prevent user from opening another one editor or toggle menu-bar: */
     actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_S_Settings)->setEnabled(false);
+#ifndef Q_WS_MAC
     actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_T_Visibility)->setEnabled(false);
+#endif /* !Q_WS_MAC */
     /* Create menu-bar editor: */
     UIMenuBarEditorWindow *pMenuBarEditor = new UIMenuBarEditorWindow(activeMachineWindow(), actionPool());
@@ -138,13 +142,18 @@
 void UIMachineLogicNormal::sltMenuBarSettingsClosed()
 {
+#ifndef Q_WS_MAC
     /* Make sure menu-bar is enabled: */
     const bool fEnabled = actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_T_Visibility)->isChecked();
     AssertReturnVoid(fEnabled);
+#endif /* !Q_WS_MAC */
 
     /* Allow user to open editor and toggle menu-bar again: */
     actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_S_Settings)->setEnabled(true);
+#ifndef Q_WS_MAC
     actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_T_Visibility)->setEnabled(true);
-}
-
+#endif /* !Q_WS_MAC */
+}
+
+#ifndef RT_OS_DARWIN
 void UIMachineLogicNormal::sltToggleMenuBar()
 {
@@ -156,4 +165,5 @@
     gEDataManager->setMenuBarEnabled(!fEnabled, vboxGlobal().managedVMUuid());
 }
+#endif /* !RT_OS_DARWIN */
 
 void UIMachineLogicNormal::sltOpenStatusBarSettings()
@@ -247,6 +257,8 @@
     connect(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_S_Settings), SIGNAL(triggered(bool)),
             this, SLOT(sltOpenMenuBarSettings()));
+#ifndef Q_WS_MAC
     connect(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_T_Visibility), SIGNAL(triggered(bool)),
             this, SLOT(sltToggleMenuBar()));
+#endif /* !Q_WS_MAC */
     connect(actionPool()->action(UIActionIndexRT_M_View_M_StatusBar_S_Settings), SIGNAL(triggered(bool)),
             this, SLOT(sltOpenStatusBarSettings()));
@@ -338,6 +350,8 @@
     disconnect(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_S_Settings), SIGNAL(triggered(bool)),
                this, SLOT(sltOpenMenuBarSettings()));
+#ifndef Q_WS_MAC
     disconnect(actionPool()->action(UIActionIndexRT_M_View_M_MenuBar_T_Visibility), SIGNAL(triggered(bool)),
                this, SLOT(sltToggleMenuBar()));
+#endif /* !Q_WS_MAC */
     disconnect(actionPool()->action(UIActionIndexRT_M_View_M_StatusBar_S_Settings), SIGNAL(triggered(bool)),
                this, SLOT(sltOpenStatusBarSettings()));
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.h	(revision 54443)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.h	(revision 54459)
@@ -51,6 +51,8 @@
     /** Handles menu-bar editor closing.*/
     void sltMenuBarSettingsClosed();
+#ifndef RT_OS_DARWIN
     /** Toggles menu-bar presence.*/
     void sltToggleMenuBar();
+#endif /* !RT_OS_DARWIN */
 
     /** Opens status-bar editor.*/